The robust_rename() function now takes a "partialptr" arg that, if
[rsync/rsync.git] / testsuite / rsync.fns
CommitLineData
d820215b
MP
1#! /bin/sh
2
3# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5# General-purpose test functions for rsync.
3a4c683f 6
0154b302
MP
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License version
9# 2 as published by the Free Software Foundation.
10#
11# This program is distributed in the hope that it will be useful, but
12# WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14# Lesser General Public License for more details.
15#
16# You should have received a copy of the GNU Lesser General Public
17# License along with this program; if not, write to the Free Software
18# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
20
6f481bb0 21tmpdir="$scratchdir"
e3442095
WD
22fromdir="$tmpdir/from"
23todir="$tmpdir/to"
24chkdir="$tmpdir/chk"
3a4c683f 25
2094283b 26# Berkley's nice.
96553aa7 27PATH="$PATH:/usr/ucb"
2094283b 28
e3442095 29if diff -u "$srcdir/testsuite/rsync.fns" "$srcdir/testsuite/rsync.fns" >/dev/null 2>&1; then
84229c7a
WD
30 diffopt="-u"
31else
32 diffopt="-c"
33fi
34
a98cad00
WD
35HOME="$scratchdir"
36export HOME
37
3a4c683f
MP
38runtest() {
39 echo $ECHO_N "Test $1: $ECHO_C"
501972bf
MP
40 if eval "$2"
41 then
6f481bb0 42 echo "$ECHO_T done."
501972bf
MP
43 return 0
44 else
6f481bb0 45 echo "$ECHO_T failed!"
501972bf
MP
46 return 1
47 fi
3a4c683f
MP
48}
49
50printmsg() {
51 echo "$1"
52}
53
e052b21f 54
6773a779 55rsync_ls_lR() {
22558cdd 56 find "$@" -print | sort | sed 's/ /\\ /g' | xargs "$TOOLDIR/tls"
dfef3f10
MP
57}
58
59rsync_getgroups() {
60 "$TOOLDIR/getgroups"
57835c00
MP
61}
62
63
e052b21f 64####################
6f481bb0 65# Build test directories $todir and $fromdir, with $fromdir full of files.
e052b21f 66
3a4c683f 67hands_setup() {
501972bf 68 # Clean before creation
6f481bb0
WD
69 rm -rf "$fromdir"
70 rm -rf "$todir"
3d807132 71
e3442095
WD
72 [ -d "$tmpdir" ] || mkdir "$tmpdir"
73 [ -d "$fromdir" ] || mkdir "$fromdir"
74 [ -d "$todir" ] || mkdir "$todir"
3a4c683f 75
e052b21f
MP
76 # On some BSD systems, the umask affects the mode of created
77 # symlinks, even though the mode apparently has no effect on how
78 # the links behave in the future, and it cannot be changed using
79 # chmod! rsync always sets its umask to 000 so that it can
80 # accurately recreate permissions, but this script is probably run
81 # with a different umask.
82
83 # This causes a little problem that "ls -l" of the two will not be
84 # the same. So, we need to set our umask before doing any creations.
85
3a4c683f 86 # set up test data
6f481bb0
WD
87 touch "$fromdir/empty"
88 mkdir "$fromdir/emptydir"
e8ca5901 89
571a4b26 90 # a hundred lines of text or so
6f481bb0 91 rsync_ls_lR "$srcdir" > "$fromdir/filelist"
3a4c683f 92
6f481bb0 93 echo $ECHO_N "This file has no trailing lf$ECHO_C" > "$fromdir/nolf"
0154b302 94 umask 0
6f481bb0 95 ln -s nolf "$fromdir/nolf-symlink"
4c80c473 96 umask 022
0154b302 97
db10766a 98 cat "$srcdir"/*.c > "$fromdir/text"
6f481bb0
WD
99 mkdir "$fromdir/dir"
100 cp "$fromdir/text" "$fromdir/dir"
101 mkdir "$fromdir/dir/subdir"
102 echo some data > "$fromdir/dir/subdir/foobar.baz"
103 mkdir "$fromdir/dir/subdir/subsubdir"
a7a1cc2c
WD
104 if [ -r /etc ]; then
105 ls -ltr /etc > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
106 else
107 ls -ltr / > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
108 fi
6f481bb0 109 mkdir "$fromdir/dir/subdir/subsubdir2"
a7a1cc2c
WD
110 if [ -r /bin ]; then
111 ls -lt /bin > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
112 else
113 ls -lt / > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
114 fi
7d691654 115
8f98c608 116# echo testing head:
6f481bb0 117# ls -lR "$srcdir" | head -10 || echo failed
3a4c683f 118}
3fedd74b
MP
119
120
99cdaff7
MP
121####################
122# Many machines do not have "mkdir -p", so we have to build up long paths.
123# How boring.
124makepath () {
7c1b7890 125 echo " makepath $1"
99cdaff7
MP
126 p="$1"
127 (
128 # Absolut Unix.
129 if echo $p | grep '^/' >/dev/null
130 then
131 cd /
132 fi
133
134 # This will break if $1 contains a space.
135 for c in `echo $p | tr '/' ' '`
136 do
112e7311
MP
137 if [ -d "$c" ] || mkdir "$c"
138 then
139 cd "$c" || return $?
140 else
141 echo "failed to create $c" >&2; return $?
142 fi
99cdaff7
MP
143 done
144 )
145}
146
147
148
3fedd74b
MP
149###########################
150# Run a test (in '$1') then compare directories $2 and $3 to see if
151# there are any difference. If there are, explain them.
152
f494f286
MP
153# So normally basically $1 should be an rsync command, and $2 and $3
154# the source and destination directories. This is only good when you
155# expect to transfer the whole directory exactly as is. If some files
156# should be excluded, you might need to use something else.
157
3fedd74b 158checkit() {
3fedd74b 159 failed=
3fedd74b 160
cf72f204
MP
161 # We can just write everything to stdout/stderr, because the
162 # wrapper hides it unless there is a problem.
163
164 echo "Running: \"$1\""
165 eval "$1"
3fedd74b
MP
166 status=$?
167 if [ $status != 0 ]; then
168 failed="YES";
169 fi
170
cf72f204
MP
171 echo "-------------"
172 echo "check how the directory listings compare with diff:"
173 echo ""
6f481bb0
WD
174 ( cd "$2" && rsync_ls_lR . ) > "$tmpdir/ls-from"
175 ( cd "$3" && rsync_ls_lR . ) > "$tmpdir/ls-to"
176 diff $diffopt "$tmpdir/ls-from" "$tmpdir/ls-to" || failed=YES
30688bf1
WD
177
178 echo "-------------"
179 echo "check how the files compare with diff:"
180 echo ""
181 if [ "x$4" != x ]; then
182 echo " === Skipping (as directed) ==="
183 else
184 diff -r $diffopt "$2" "$3" || failed=YES
185 fi
186
187 echo "-------------"
6f481bb0 188 if [ -z "$failed" ] ; then
3fedd74b
MP
189 return 0
190 else
3fedd74b
MP
191 return 1
192 fi
193}
194
863dff51 195
4a7cb3e8 196build_rsyncd_conf() {
d2094cc3
MP
197 # Build an appropriate configuration file
198 conf="$scratchdir/test-rsyncd.conf"
199 echo "building configuration $conf"
200
201 port=2612
202 pidfile="$scratchdir/rsyncd.pid"
203 logfile="$scratchdir/rsyncd.log"
204
6f481bb0 205 cat >"$conf" <<EOF
3aae15ec 206# rsyncd configuration file autogenerated by $0
d2094cc3 207
3aae15ec
MP
208pid file = $pidfile
209use chroot = no
210hosts allow = localhost, 127.0.0.1
211log file = $logfile
6f481bb0 212exclude = foobar.baz
eddeaf76 213max verbosity = 9
d2094cc3 214
76ee1d18
WD
215uid = 0
216gid = 0
98c1b325 217
2e6c7f45 218[test-from]
6f481bb0 219 path = $fromdir
3aae15ec 220 read only = yes
d2094cc3 221
2e6c7f45 222[test-to]
6f481bb0 223 path = $todir
3aae15ec 224 read only = no
d2094cc3
MP
225EOF
226}
227
228
3cd2af41 229build_symlinks() {
3cd2af41
MP
230 mkdir "$fromdir"
231 date >"$fromdir/referent"
232 ln -s referent "$fromdir/relative"
233 ln -s "$fromdir/referent" "$fromdir/absolute"
234 ln -s nonexistent "$fromdir/dangling"
1db8b61d 235 ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
3cd2af41
MP
236}
237
238test_fail() {
239 echo "$@" >&2
240 exit 1
241}
242
a217ad30
MP
243test_skipped() {
244 echo "$@" >&2
6f481bb0 245 echo "$@" > "$tmpdir/whyskipped"
a217ad30
MP
246 exit 77
247}
248
be2f866b
MP
249# It failed, but we expected that. don't dump out error logs,
250# because most users won't want to see them. But do leave
251# the working directory around.
252test_xfail() {
253 echo "$@" >&2
254 exit 78
255}
256
d1239eae
MP
257# Determine what shell command will appropriately test for links.
258ln -s foo "$scratchdir/testlink"
259for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
260do
261 for switch in -h -L
262 do
263 if $cmd $switch "$scratchdir/testlink" 2>/dev/null
264 then
265 # how nice
266 TEST_SYMLINK_CMD="$cmd $switch"
267 # i wonder if break 2 is portable?
268 break 2
269 fi
270 done
271done
cca4e067
MP
272# ok, now get rid of it
273rm "$scratchdir/testlink"
d1239eae
MP
274
275
276if [ "x$TEST_SYMLINK_CMD" = 'x' ]
277then
278 test_fail "Couldn't determine how to test for symlinks"
279else
280 echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
281fi
282
283
d96d3893
MP
284# Test whether something is a link, allowing for shell peculiarities
285is_a_link() {
d1239eae
MP
286 # note the variable contains the first option and therefore is not quoted
287 $TEST_SYMLINK_CMD "$1"
d96d3893
MP
288}
289
77867907
MP
290
291# We need to set the umask to be reproducible. Note also that when we
292# do some daemon tests as root, we will setuid() and therefore the
293# directory has to be writable by the nobody user in some cases. The
294# best thing is probably to explicitly chmod those directories after
295# creation.
296
ad301e48 297umask 022